/* no javadoc comments on file level except for classes and rules */
options {
	language="Python";
    //language="Java";  //<- should at least generate a warning
}

{
    def myfunc() :
        print "myfunc"
}

class parser extends Parser("Parser0");
options {
    k=3;
	buildAST = true;
    //ASTLabelType = "TNode";
    exportVocab=Calc;
}


tokens {
    BODY;
    STMT;
    EXPR;
    TOK01;		
    UNARY_MINUS;
	UNARY_PLUS;
}

{
    ## python stuff here
    def hello(self):
        print "hello, world"
}

body
    : "begin"!
        (expr ";"!)+
      "end"!
    ;

id 
    : 
        VALID | TYPID | CLSID
    ;


expr
    : 
        expr1
        { ## = #(#[EXPR,"expr"],##); }
    ;

expr1
    :   
        expr2 ((MINUS^|PLUS^) expr2)*
    ;

expr2
    :   
        expr3 ((MULT^|DIV^) expr3)*
    ;

expr3
    : 
        (   p:PLUS   { #p.setType(UNARY_PLUS)  }
        |   m:MINUS  { #m.setType(UNARY_MINUS) }
        )* expr4
    ;

expr4
    : 
      NUMBER
    | LPAREN^ expr1 RPAREN!
    ;


class walker extends TreeParser("Walker0");
options {
    //ASTLabelType = "TNode";
}

body returns [float s]
{
    s = 0;
    float r = 0;
}
    : ( #(e:EXPR { r=expr(e); s += r; print(e.toStringTree());println(" => " + r);} ) )*
    ;

expr returns [float r]
{
    r = 0;
}
    : #(EXPR r=expr0())
    ;

expr0 returns [float r] {
    float b = 0;
	r=0;
}
    : UNARY_MINUS r=expr0()         { r=-r;}
    | UNARY_PLUS  r=expr0()
    | j:INT                         { r = tofloat(j); }
    | #(PLUS   r=expr0() b=expr0()) { r = r + b; }
    | #(MINUS  r=expr0() b=expr0()) { r = r - b; } 
    | #(MULT   r=expr0() b=expr0()) { r = r * b; }
    | #(DIV    r=expr0() b=expr0()) { r = r / b; } 
    | #(LPAREN r=expr0())
	;

nullp
{
    int i = 1;
    if( #nullp == null ) {
        return;
    }
    System.err.println(" error in parser tree .. ");
    System.err.println(#nullp.toStringTree());
    
    if(i>0)
     return; 
    
}
    : #(INT INT) 
        {
        }
    ;


/* standard lexer - not of further interest here */
class lexcalc extends Lexer;


WS	:	(' '
	|	'\t'
	|	'\n' { self.newline(); }
	|	'\r')
		{ _ttype = SKIP }
	;

LPAREN:	'('
	;

RPAREN:	')'
	;

MULT:	'*'
	;

DIV
    : '/'
    ;

PLUS:	'+'
	;

MINUS
    : '-'
    ;

SEMI:	';'
	;

AND:   '&'  
    ;

OR:     '|'
    ;

NOT:    '!'
    ;

EQ :   '='
    ;


protected
DIGIT
	:	'0'..'9'
	;

protected
INT	:	(DIGIT)+
	;


NUMBER
    : INT ("." INT)?
    ;
        

protected
LOWER
    : 'a'..'z'
    ;

protected
UPPER
    : 'A'..'Z'
    ;

protected
LETTER
    : UPPER | LOWER
    ;

ID 
    :
        LOWER (LETTER|DIGIT|'-')* {
            $setType(VALID)
        }
    |   (UPPER (UPPER|DIGIT|'-')*) => UPPER (UPPER|DIGIT|'-')* {
            $setType(CLSID)
        }
    |   (UPPER (UPPER|LOWER|DIGIT|'-')*)  {
            buffer = $getText
            $setType(TYPID)
        }
    ;
